package meerkat.bulletinboard;

import meerkat.bulletinboard.sqlserver.EnhancedSQLiteBulletinBoardServer;
import meerkat.comm.CommunicationException;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.File;

import static org.junit.Assert.fail;

/**
 * Created by Arbel Deutsch Peled on 07-Dec-15.
 */
public class EnhancedSQLiteBulletinBoardServerTest{

    private String testFilename = "EnhancedSQLiteDBTest.db";

    private GenericBulletinBoardServerTest serverTest;

    @Before
    public void init(){

        File old = new File(testFilename);
        old.delete();

        BulletinBoardServer bulletinBoardServer = new EnhancedSQLiteBulletinBoardServer();
        try {
            bulletinBoardServer.init(testFilename);

        } catch (CommunicationException e) {
            System.err.println("Failed to initialize server " + e.getMessage());
            fail("Failed to initialize server " + e.getMessage());
            return;
        }

        serverTest = new GenericBulletinBoardServerTest();
        serverTest.init(bulletinBoardServer);
    }

    @Test
    public void bulkTest() {
        System.err.println("Testing Enhanced SQLite Server");
        serverTest.testInsert();
        serverTest.testSimpleTagAndSignature();
    }

    @After
    public void close() {
        serverTest.close();
    }

}
