package meerkat.bulletinboard;

import meerkat.bulletinboard.sqlserver.SQLiteBulletinBoardServer;
import meerkat.comm.CommunicationException;
import meerkat.protobuf.*;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.File;
import java.io.IOException;
import java.security.*;
import java.security.cert.CertificateException;

import static org.junit.Assert.fail;

/**
 * Created by Arbel Deutsch Peled on 07-Dec-15.
 */
public class SQLiteBulletinBoardServerTest{

    private String testFilename = "SQLiteDBTest.db";

    private GenericBulletinBoardServerTest serverTest;

    @Before
    public void init(){

        File old = new File(testFilename);
        old.delete();

        BulletinBoardServer bulletinBoardServer = new SQLiteBulletinBoardServer();
        try {
            bulletinBoardServer.init(testFilename);

        } catch (CommunicationException e) {
            System.err.println(e.getMessage());
            fail(e.getMessage());
            return;
        }

        serverTest = new GenericBulletinBoardServerTest();
        try {
            serverTest.init(bulletinBoardServer);
        } catch (Exception e) {
            System.err.println(e.getMessage());
            fail(e.getMessage());
        }
    }

    @Test
    public void bulkTest() {
        try {
            serverTest.testInsert();
            serverTest.testSimpleTagAndSignature();
        } catch (Exception e) {
            System.err.println(e.getMessage());
            fail(e.getMessage());
        }
    }

    @After
    public void close() {
        serverTest.close();
    }

}
